package nl.tue.id.zoo.animal;

import nl.tue.id.zoo.util.*;
import nl.tue.id.zoo.food.Food;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2007</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
abstract public class Animal implements LifeHolder {
    private Life life;
    private double weight;

    public Animal() {
        birth();
    }

    private void birth() {
        life = new Life(this);
        setBirthWeight();
    }

    public long getAge() {
        return life.HowOldAreYou();
    }

    abstract public void move();

    abstract public void speak();

    abstract public void eat(Food food);

    protected void setWeight(double weight) {
        this.weight = weight;
    }

    public double getWeight() {
        return weight;
    }

    protected void setBirthWeight() {
        setWeight(0);
    }


    public void LifeGoesOn() {
        System.out.println("Happily living animal.");
    }

    public void Sleep() {
        System.out.println("Sleeping now");
    }

    public void Getup() {
        System.out.println("Getting up now.");
    }

    public void Birthday() {
        beHappy();
        System.out.println("Happy birthday to me, I am now " +
                           getAge() + " year old, " +
                           getWeight() + "kilo big.");
    }

    protected void beHappy(){
        move();
        speak();
        move();
        speak();
        move();
        speak();
    }
}
